-- Author: dxet34
-- Date: 24.08.2022
-- Version: 1.0.0.0


AutoLightOnOff = {};

AutoLightOnOff.updateDelta = 2001;    	-- time since the last update
AutoLightOnOff.updateRate = 2000;  	-- milliseconds until next update


function AutoLightOnOff:update(dt)
	AutoLightOnOff.updateDelta = AutoLightOnOff.updateDelta + dt;
	
	if g_currentMission.player == nil and g_currentMission.controlledVehicle == nil then
		-- print("  No player or controlled vehicle!");
		return;
    end;

	if AutoLightOnOff.updateDelta > AutoLightOnOff.updateRate then
		-- print("AutoLightOnOff:update");
		AutoLightOnOff.updateDelta = 0;
		if g_currentMission:getIsClient() and g_gui.currentGui == nil then
    		local needLights = not g_currentMission.environment.isSunOn
			local curVehicle = g_currentMission.controlledVehicle;

			-- print("***AutoLightOnOff:update: Light Control***")
			if curVehicle ~= nil and curVehicle.spec_lights ~= nil then
				if curVehicle.getIsAIActive == nil or not curVehicle:getIsAIActive() then
					if not AutoLightOnOff:getIsLightTurnedOn(curVehicle) and needLights then
						-- print("AutoLightOnOff:update: Light On: " .. g_currentMission.environment.currentHour);
						curVehicle:setNextLightsState(curVehicle.spec_lights.numLightTypes);
					end;
					if AutoLightOnOff:getIsLightTurnedOn(curVehicle) and not needLights then
						-- print("AutoLightOnOff:update: Light Off: " .. g_currentMission.environment.currentHour);
						curVehicle:deactivateLights(true);
					end;
				end;
			elseif g_currentMission.player ~= nil and g_currentMission.player.isLightActive ~= needLights then
				g_currentMission.player:setLightIsActive(needLights)
			end;
		end;
	end;
end;

function AutoLightOnOff:getIsLightTurnedOn(vehObj)
	if vehObj.spec_lights ~= nil and vehObj.spec_lights.currentLightState > 0 then
		return true;
	else
		return false
	end;
end;

-- function AutoLightOnOff:loadMap(name) end;
-- function AutoLightOnOff:registerActionEvents() end;
-- function AutoLightOnOff:onLoad(savegame)end;
-- function AutoLightOnOff:onUpdate(dt)end;
-- function AutoLightOnOff:deleteMap()end;
-- function AutoLightOnOff:keyEvent(unicode, sym, modifier, isDown)end;
-- function AutoLightOnOff:mouseEvent(posX, posY, isDown, isUp, button)end;
-- function AutoLightOnOff:draw()end;

addModEventListener(AutoLightOnOff);